#line 723 "./lpsrc/flx_faio.pak"
#ifndef __FLXDRV__
#define __FLXDRV__
#include <flx_faio_config.hpp>

#include "pthread_sleep_queue.hpp"
#include "pthread_work_fifo.hpp"
#include "demux_timer_queue.hpp"
#include "demux_demuxer.hpp"

namespace flx { namespace faio {
// vestigal driver class is all that remains of the embedded driver from
// which faio came. all it is now is a pointer to a queue.
// watch this space.
class FAIO_EXTERN flx_drv {
    flx::pthread::sleep_queue_t&    ready_queue;
    flx::pthread::worker_fifo     work_fifo;
public:
    flx_drv(
      flx::pthread::sleep_queue_t& q,
      int qbound, int nthreads
    );
    virtual ~flx_drv();

    void sched(void* f);

    flx::pthread::worker_fifo* get_worker_fifo() { return &work_fifo; }
    virtual demux::timer_queue* get_sleepers() = 0;
};

// this becomes socket thread wakeup. um.
class FAIO_EXTERN thread_wakeup {
public:
    void wake() { drv->sched(f); }

    void*           f;              // thread to be woken
    flx_drv*        drv;            // in which driver
};

// to be called inside every start_async_op
// note: the windows version often needs the demuxer, but the posix one
// doesn't. I forget why.
#define RECORD_THREAD_INFO(w) (w).f=f;\
                              (w).drv=drv;

}}
#endif              //__FLXDRV__


