#line 216 "./lpsrc/flx_lib.ipk"
#include "flx_strutil.hpp"

namespace flx { namespace rtl { namespace strutil {

  string atostr(char const *a) {
    if(a) return a;
    else return "";
  }

 string ltrim(string const &x) {
   int n = x.size();
   int i;
   for(i = 0; i < n; ++i)
     if(x[i]>' ')break;
   return x.substr(i,n-i);
 }

 string rtrim(string const &x) {
   int n = x.size();
   int i;
   for(i = n; i > 0; --i)
     if(x[i-1]>' ')break;
   return x.substr(0,i);
 }

#ifdef HAVE_VSNPRINTF
  string flx_asprintf(char *fmt,...){
    va_list ap;
    va_start(ap,fmt);
    int n = vsnprintf(NULL,0,fmt,ap);
    va_end(ap);
    char *res = (char*)malloc(n+1);
    va_start(ap,fmt);
    vsnprintf(res,n+1,fmt,ap);
    va_end(ap);
    string s = string(res);
    free(res);
    return s;
  }
#else
  // THIS IS UNSAFE .. but Windows sucks.
  // It documents vsnprintf .. but doesn't provide it
  string flx_asprintf(char *fmt,...){
    va_list ap;
    int n = 1000;
    char *res = (char*)malloc(n+1);
    va_start(ap,fmt);
    vsprintf(res,fmt,ap);
    va_end(ap);
    string s = string(res);
    free(res);
    return s;
  }
#endif

}}}

